Package com.io7m.cedarbridge.runtime.api

# Record Class CBSome<T extends CBSerializableType>

java.lang.Object
java.lang.Record
com.io7m.cedarbridge.runtime.api.CBSome<T>

Type Parameters:
  `T` - The type of values
Record Components:
  `value` - The present value

All Implemented Interfaces:
  `CBOptionType<T>`, `CBSerializableType`, `Formattable`

public record CBSome<T extends CBSerializableType>(T extends CBSerializableType value) extends Record implements CBOptionType<T>
The Some case.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CBSome(T value)`
  The Some case.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Optional<T>`
  `asOptional()`
  `static <T extends CBSerializableType>
  CBSome<T>`
  `deserialize(CBSerializationContextType context, CBDeserializeType<T> ft)`
  Deserialize the given value.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `void`
  `formatTo(Formatter formatter, int flags, int width, int precision)`
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `static <T extends CBSerializableType>
  void`
  `serialize(CBSerializationContextType context, CBSome<T> x, CBSerializeType<T> ft)`
  Serialize the given value.
  `final String`
  `toString()`
  Returns a string representation of this record class.
  `T`
  `value()`
  Returns the value of the `value` record component.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CBSome

    public CBSome(T value)
    The Some case.
    Parameters:
      `value` - The present value

- ## Method Details

  - ### formatTo

    public void formatTo(Formatter formatter, int flags, int width, int precision)
    Specified by:
      `formatTo` in interface `Formattable`

  - ### asOptional

    public Optional<T> asOptional()
    Specified by:
      `asOptional` in interface `CBOptionType<T extends CBSerializableType>`
    Returns:
      This value as a Java Optional

  - ### serialize

    public static <T extends CBSerializableType> void serialize(CBSerializationContextType context, CBSome<T> x, CBSerializeType<T> ft) throws IOException
    Serialize the given value.
    Type Parameters:
      `T` - The type of list values
    Parameters:
      `context` - The serialization context
      `x` - The value
      `ft` - A serializer for `T`
    Throws:
      `IOException` - On errors

  - ### deserialize

    public static <T extends CBSerializableType> CBSome<T> deserialize(CBSerializationContextType context, CBDeserializeType<T> ft) throws IOException
    Deserialize the given value.
    Type Parameters:
      `T` - The type of optional values
    Parameters:
      `context` - The serialization context
      `ft` - A deserializer for `T`
    Returns:
      The deserialized value
    Throws:
      `IOException` - On errors

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### value

    public T value()
    Returns the value of the `value` record component.
    Returns:
      the value of the `value` record component